Cabal-1.22.5.0: A framework for packaging Haskell software

Copyright | Simon Marlow 2004
License | BSD3
Maintainer | cabal-devel@haskell.org
Portability | portable
Safe Haskell | None
Language | Haskell98

Distribution.Simple.SrcDist

Contents

- The top level action
  - Parts of `sdist`
  - Snapshots
- Extracting the source files

Description

This handles the `sdist` command. The module exports an `sdist` action but also some of the phases that make it up so that other tools can use just the bits they need. In particular the preparation of the tree of files to go into the source tarball is separated from actually building the source tarball.

The `createArchive` action uses the external `tar` program and assumes that it accepts the `-z` flag. Neither of these assumptions are valid on Windows. The `sdist` action now also does some distribution QA checks.

Synopsis

- sdist :: PackageDescription -> Maybe LocalBuildInfo -> SDistFlags -> (FilePath -> FilePath) -> [PPSuffixHandler] -> IO ()
- printPackageProblems :: Verbosity -> PackageDescription -> IO ()
- prepareTree :: Verbosity -> PackageDescription -> Maybe LocalBuildInfo -> FilePath -> [PPSuffixHandler] -> IO ()
- createArchive :: CreateArchiveFun
- prepareSnapshotTree :: Verbosity -> PackageDescription -> Maybe LocalBuildInfo -> FilePath -> [PPSuffixHandler] -> IO ()
- snapshotPackage :: UTCTime -> PackageDescription -> PackageDescription
- snapshotVersion :: UTCTime -> Version -> Version
- dateToSnapshotNumber :: UTCTime -> Int
- listPackageSources :: Verbosity -> PackageDescription -> [PPSuffixHandler] -> IO ([FilePath], [FilePath])

# The top level action

sdist Source

Arguments

:: PackageDescription | information from the tarball
-> Maybe LocalBuildInfo | Information from configure
-> SDistFlags | verbosity & snapshot
-> (FilePath -> FilePath) | build prefix (temp dir)
-> [PPSuffixHandler] | extra preprocessors (includes suffixes)
-> IO () |

Create a source distribution.

## Parts of `sdist`

printPackageProblems :: Verbosity -> PackageDescription -> IO () Source

prepareTree Source

Arguments

:: Verbosity | verbosity
-> PackageDescription | info from the cabal file
-> Maybe LocalBuildInfo |
-> FilePath | source tree to populate
-> [PPSuffixHandler] | extra preprocessors (includes suffixes)
-> IO () |

Prepare a directory tree of source files.

createArchive :: CreateArchiveFun Source

Create an archive from a tree of source files, and clean up the tree.

## Snapshots

prepareSnapshotTree Source

Arguments

:: Verbosity | verbosity
-> PackageDescription | info from the cabal file
-> Maybe LocalBuildInfo |
-> FilePath | source tree to populate
-> [PPSuffixHandler] | extra preprocessors (includes suffixes)
-> IO () |

Prepare a directory tree of source files for a snapshot version. It is expected that the appropriate snapshot version has already been set in the package description, eg using `snapshotPackage` or `snapshotVersion`.

snapshotPackage :: UTCTime -> PackageDescription -> PackageDescription Source

Modifies a `PackageDescription` by appending a snapshot number corresponding to the given date.

snapshotVersion :: UTCTime -> Version -> Version Source

Modifies a `Version` by appending a snapshot number corresponding to the given date.

dateToSnapshotNumber :: UTCTime -> Int Source

Given a date produce a corresponding integer representation. For example given a date `18032008` produce the number `20080318`.

# Extracting the source files

listPackageSources Source

Arguments

:: Verbosity | verbosity
-> PackageDescription | info from the cabal file
-> [PPSuffixHandler] | extra preprocessors (include suffixes)
-> IO ([FilePath], [FilePath]) |

List all source files of a package. Returns a tuple of lists: first component is a list of ordinary files, second one is a list of those files that may be executable.